VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlugIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' MaxIm DL processing plug-in sample
' Copyright (c) 2001 Diffraction Limited
'
' This file contains all the properties and methods required for the plug-in
' Make sure that MaxIm objects are selected under Project menu References
' and change the project name under Project menu Properties to get a unique
' GUID

Option Explicit

' MaxIm DL gives you a pointer to the currently selected MaxIm.Document
Public Sub DoModal(ByVal Doc As maxim.Document)
    Dim Max As maxim.Document
    Dim V As Variant
    Dim XSize As Integer
    Dim YSize As Integer
    Dim m, n, Med(4), MaxMed As Double
    Dim x, y As Integer
    
    ' Get the image array
    Set Max = Doc
    V = Max.ImageArray
    
    If Not Max.Color Then
        m = 0
        n = 0
        For y = 0 To Max.YSize - 1 Step 2
            For x = 0 To Max.XSize - 1 Step 2
                m = m + V(x, y)
                n = n + 1
            Next
        Next
        Med(0) = m / n
        MaxMed = Med(0)
        m = 0
        n = 0
        For y = 0 To Max.YSize - 1 Step 2
            For x = 1 To Max.XSize - 1 Step 2
                m = m + V(x, y)
                n = n + 1
            Next
        Next
        Med(1) = m / n
        If Med(1) > MaxMed Then
            MaxMed = Med(1)
        End If
        
        m = 0
        n = 0
        For y = 1 To Max.YSize - 1 Step 2
            For x = 0 To Max.XSize - 1 Step 2
                m = m + V(x, y)
                n = n + 1
            Next
        Next
        Med(2) = m / n
        If Med(2) > MaxMed Then
            MaxMed = Med(2)
        End If
        
        m = 0
        n = 0
        For y = 1 To Max.YSize - 1 Step 2
            For x = 1 To Max.XSize - 1 Step 2
                m = m + V(x, y)
                n = n + 1
            Next
        Next
        Med(3) = m / n
        If Med(3) > MaxMed Then
            MaxMed = Med(3)
        End If
        
        For y = 0 To Max.YSize - 1
            For x = 0 To Max.XSize - 1
                If y And 1 Then
                    If x And 1 Then
                        V(x, y) = V(x, y) * MaxMed / Med(3)
                    Else
                        V(x, y) = V(x, y) * MaxMed / Med(2)
                    End If
                Else
                    If x And 1 Then
                        V(x, y) = V(x, y) * MaxMed / Med(1)
                    Else
                        V(x, y) = V(x, y) * MaxMed / Med(0)
                    End If
                End If
            Next
        Next
    End If
    
    ' Update the document in MaxIm
    Max.ImageArray = V

End Sub

' Return the name which will appear on the MaxIm DL PlugIn menu
Public Property Get Name() As String
    Name = "Normalize Colorchip Flat"
End Property
